package com.kexun.controller;

import net.coobird.thumbnailator.Thumbnails;
import org.springframework.core.io.FileSystemResource;
import com.alibaba.fastjson.JSONObject;
import com.kexun.entity.ModelEntity;
import org.apache.commons.io.FileUtils;
import org.springframework.core.io.Resource;
import org.springframework.core.io.UrlResource;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.*;
import java.net.URLEncoder;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.Files;
import java.util.Base64;

import org.springframework.util.StringUtils;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;

//import ch.qos.logback.core.rolling.helper.FileStoreUtil;
//import ch.qos.logback.core.util.FileUtil;

import com.kexun.common.FileUploadUtil;
import com.kexun.common.utils.Result;
import com.kexun.entity.SysUser;
import com.kexun.entity.UserApproval;
import com.kexun.service.UserApprovalService;
import com.kexun.service.UserModelService;
import lombok.extern.java.Log;
//import org.aspectj.util.FileUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.FileCopyUtils;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.imageio.ImageIO;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.swing.*;
import javax.swing.filechooser.FileSystemView;

/**
 * @Author zhangming
 * @Date 2020/5/15 15:47
 */
/*
未改动
 * 目标：此处是用户模型及审批结果的相关操作，用户模型及审批结果各自有表
 * 目前：此处调用的路径未集成到api.index.js中，在前端otherModel具体的方法调用时指明具体路径
 * 此外，用户模型所对应的审批逻辑未入库，将审批逻辑以json文件存入服务器中
 */

@RestController
@RequestMapping("/admin/othermodel")
@Log
public class FileUploadController {
    @Autowired
    private UserModelService userModelService;
    @Autowired
    private UserApprovalService userApprovalService;


    @Value("${config.fileupload.path}")
    private String fileuploadPath;

    @Value("${config.fileupload.warpath}")
    private String warPath;


    @GetMapping("/download/{filename}")
    public Result downloadFile(@PathVariable("filename") String filename, SysUser sysUser) throws IOException {
        String filePath = fileuploadPath + sysUser.getUserName() + '/' + filename; // 设置文件路径
        File file = new File(filePath);


        if (file.exists()) {
            byte[] fileContent = Files.readAllBytes(file.toPath());
            String base64 = Base64.getEncoder().encodeToString(fileContent);
            JSONObject resJson = new JSONObject();
            resJson.put("file", base64);
            return Result.success("ok", resJson);
        } else {
            return Result.error("文件不存在!");
        }

    }

    @PostMapping("/filechange")
    public Result filechange(@RequestParam Integer index, @RequestParam MultipartFile chunk, @RequestParam String name, @RequestParam Integer chunksLength, @RequestParam String uid
            , @RequestParam String output_list, SysUser sysUser, @RequestParam long id
    ) throws IOException {
        String filename = name.split("\\.")[0];
        String filefmt = name.split("\\.")[1];
        String fullFileName = String.join("-", new String[]{filename, uid, index + "", "." + filefmt});
        String filePath = fileuploadPath + "/" + sysUser.getUserName() + "/" + filename + "." + filefmt;
        log.info("filename:" + fullFileName);
        File dir = new File(fileuploadPath + "/" + sysUser.getUserName() + "/");

        if (!dir.exists()) {
            dir.mkdirs();
        }
        File file = new File(fileuploadPath + "/" + sysUser.getUserName() + "/" + fullFileName);
        FileCopyUtils.copy(chunk.getInputStream(), new FileOutputStream(file));
        FileUploadUtil.put(uid, index, chunksLength, fullFileName, fileuploadPath + "/" + sysUser.getUserName() + "/");
        // 检测所有文件是否上传完成
        boolean isAllChunksUploaded = FileUploadUtil.isAllChunksUploaded(uid);
        //当前步骤这一步一定完成
        try {
            if (isAllChunksUploaded) {
                FileUploadUtil.mergeChunks(name, uid);
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new RuntimeException(ex.getMessage());
        }

        ModelEntity modelEntity = userModelService.findByID(id);
        String oldFilePath = modelEntity.getFilePath();
        File oldFile = new File(oldFilePath);

        if (oldFile.exists()) {
            try {
                FileUtils.forceDelete(oldFile);
                System.out.println("file delete success");
            } catch (IOException e) {
                System.out.println("file delete fail: " + e.getMessage());
            }
        } else {
            System.out.println("file not exist");
        }

        modelEntity.setFilePath(filePath);
        userModelService.updateById(modelEntity);

        JSONObject resJson = new JSONObject();
        resJson.put("file_path", filePath);

        return Result.success("ok", resJson);
    }

    //上传用户模型及审批结果
    @PostMapping("/fileupload")
    @ResponseBody
    public Result upload2(@RequestParam Integer index, @RequestParam MultipartFile chunk, @RequestParam String name, @RequestParam Integer chunksLength, @RequestParam String uid
            , @RequestParam String model_name, @RequestParam String model_type, @RequestParam String model_no, @RequestParam String output_list, SysUser sysUser
    ) throws IOException {
        int type = Integer.parseInt(model_type);
        if (type == 1 || type == 2) {
            String filename = name.split("\\.")[0];
            String filefmt = name.split("\\.")[1];
            String fullFileName = String.join("-", new String[]{filename, uid, index + "", "." + filefmt});
            String filePath = fileuploadPath + "/" + sysUser.getUserName() + "/" + filename + "." + filefmt;
            log.info("filename:" + fullFileName);
            File dir = new File(fileuploadPath + "/" + sysUser.getUserName() + "/");

            if (!dir.exists()) {
                dir.mkdirs();
            }
            File file = new File(fileuploadPath + "/" + sysUser.getUserName() + "/" + fullFileName);
            FileCopyUtils.copy(chunk.getInputStream(), new FileOutputStream(file));
            FileUploadUtil.put(uid, index, chunksLength, fullFileName, fileuploadPath + "/" + sysUser.getUserName() + "/");
            // 检测所有文件是否上传完成
            boolean isAllChunksUploaded = FileUploadUtil.isAllChunksUploaded(uid);
            //当前步骤这一步一定完成
            try {
                if (isAllChunksUploaded) {
                    FileUploadUtil.mergeChunks(name, uid);
                }
            } catch (Exception ex) {
                ex.printStackTrace();
                throw new RuntimeException(ex.getMessage());
            }

            //审批
//            UserApproval approval=new UserApproval();
//            approval.setUserName(sysUser.getUserName());
//            approval.setApprovalId((long) 1);
//            approval.setData(model_name);
//            userApprovalService.save(approval);


            //model 数据库连接接口
            String userName = sysUser.getUserName();
            ModelEntity new_modelEntity = new ModelEntity();
            new_modelEntity.setCreateBy(sysUser.getId());
            new_modelEntity.setModelName(model_name);
            new_modelEntity.setModelType(type);
            new_modelEntity.setModelNo(model_no);
            new_modelEntity.setStatus("暂停使用");
//            new_model.setOtherData(name);
//            new_model.setOutputList(output_list);
            new_modelEntity.setFilePath(filePath);
            userModelService.save(new_modelEntity);

        } else {
            // http请求
            String filename = name.split("\\.")[0];
            String filefmt = name.split("\\.")[1];
            String fullFileName = String.join("-", new String[]{filename, uid, index + "", "." + filefmt});
            log.info("filename:" + fullFileName);
            File dir = new File(warPath);
            if (!dir.exists()) {
                dir.mkdirs();
            }
            File file = new File(warPath + "/" + fullFileName);
            FileCopyUtils.copy(chunk.getInputStream(), new FileOutputStream(file));
            FileUploadUtil.put(uid, index, chunksLength, fullFileName, warPath);
            // 检测所有文件是否上传完成
            boolean isAllChunksUploaded = FileUploadUtil.isAllChunksUploaded(uid);
            //当前步骤这一步一定完成
            try {
                if (isAllChunksUploaded) {
                    FileUploadUtil.mergeChunks(name, uid);
                }
            } catch (Exception ex) {
                ex.printStackTrace();
                throw new RuntimeException(ex.getMessage());
            }

            //审批
            UserApproval approval = new UserApproval();
            approval.setUserName(sysUser.getUserName());
            approval.setApprovalId((long) 1);


            approval.setData(model_name.split(";")[0]);

            String url_address = model_name.split(";")[1];

            userApprovalService.save(approval);


            String userName = sysUser.getUserName();
            ModelEntity new_modelEntity = new ModelEntity();
            new_modelEntity.setCreateBy(sysUser.getId());
            new_modelEntity.setModelName(model_name);
            new_modelEntity.setModelType(type);
            new_modelEntity.setStatus("暂停使用");
//                new_model.setOtherData(name);
//                new_model.setOutputList(output_list);
            new_modelEntity.setFilePath(warPath + "/" + fullFileName);
            userModelService.save(new_modelEntity);
        }
        return Result.success();
    }

    @GetMapping("/get")
    public void get(@RequestParam String name, HttpServletRequest request) {
        System.out.println("get" + "name: " + name);
    }
}
