package com.kexun.controller;


import com.alibaba.fastjson.JSONObject;
import com.kexun.annotation.HisModifyLog;
import com.kexun.common.utils.Result;
import com.kexun.entity.ReportInfo;
import com.kexun.model.dto.ReportInfoDTO;
import com.kexun.model.ro.ReportInfoRO;
import com.kexun.service.ReportInfoService;
import com.kexun.service.XmlFileHandlerService;
import com.kexun.service.xml.ParseHandleService;
import com.kexun.task.ReportParseJobHandler;
import com.kexun.utils.ParseXmlUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.io.FileUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.io.File;
import java.nio.charset.StandardCharsets;

/**
 * <p>
 * 报文信息 前端控制器
 * </p>
 *
 * @author lgs
 * @since 2023-05-10
 */
@RestController
@RequestMapping("/web")
@Api("swagger测试")
@Slf4j
public class ReportInfoController {

    @Autowired
    ReportInfoService reportInfoService;

    @Autowired
    ParseHandleService parseHandleService;

    @Autowired
    XmlFileHandlerService xmlFileHandlerService;

    @Autowired
    ReportParseJobHandler reportParseJobHandler;

    @ApiOperation("变更历史记录测试")
    @PostMapping("reportUpdate")
    @HisModifyLog(businessType = "1", module = "产品变更", serviceBean = "reportInfoServiceImpl", queryMethod = "getReportInfo", paramType = "Long", paramKey = "id")
    public Result userInfo(@RequestBody ReportInfoRO reportInfoRo) {

        ReportInfoDTO reportInfoDTO = new ReportInfoDTO();
        BeanUtils.copyProperties(reportInfoDTO,reportInfoRo);
        reportInfoService.updateReportInfo(reportInfoDTO);
        return Result.success("ok", "");

    }

    @ApiOperation("测试xml的处理情况")
    @GetMapping("text-xml")
    public Result testXMl() throws Exception {

        String path = System.getProperty("user.dir") + File.separator + "src" + File.separator + "test" + File.separator + "resources" + File.separator;
        String fileName = "TestInfo.xml";
        File file = new File(path + fileName);
        String xmlContext = FileUtils.readFileToString(file, StandardCharsets.UTF_8);
        ReportInfo reportInfo = new ReportInfo();
        log.info(xmlContext);
        parseHandleService.parseHandle(reportInfo,xmlContext);
        return Result.success("ok", "");

    }

    @ApiOperation("测试定时任务")
    @GetMapping("text-task-read")
    public Result testRead() throws Exception {

        xmlFileHandlerService.readXmlFile();
        return Result.success("ok", "");

    }

    @ApiOperation("测试定时任务")
    @GetMapping("text-task-parse")
    public Result testParse() throws Exception {

        reportParseJobHandler.parse();
        return Result.success("ok", "");

    }



}
