package com.kexun.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;

/**
 * 报文文件Entity
 */
@TableName(value = "report_file")
@Data
public class ReportFileEntity extends BaseEntity implements Serializable {

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    /**
     * 报告头信息表id
     */
    @TableField(value = "head_inf_id")
    private Long headInfId;

    /**
     * 报告编码
     */
    @TableField(value = "rpt_no")
    private String rptNo;

    /**
     * 业务申请ID
     */
    @TableField(value = "business_id")
    private Long businessId;

    /**
     * 业务申请编号
     */
    @TableField(value = "business_num")
    private String businessNum;

    /**
     * 卡法源文件-xml报文 加密
     */
    @TableField(value = "file_name")
    private String fileName;

    /**
     * 解析文件-xml 解密后的报文体
     */
    @TableField(value = "file_name_xml")
    private String fileNameXml;

    /**
     * 解析文件-txt 解析后的JSON
     */
    @TableField(value = "file_name_txt")
    private String fileNameTxt;

    /**
     * 模型文件 -调用模型后的结果文件
     */
    @TableField(value = "file_name_model")
    private String fileNameModel;


}
