package com.kexun.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 逾期(透支)信息汇总 
 * </p>
 *
 * @author lgs
 * @since 2023-06-07
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_smry_overdraft")
@ApiModel(value="SmryOverdraftEntity对象", description="逾期(透支)信息汇总 ")
public class SmryOverdraftEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "账户类型代码")
    @TableField("acc_type_code")
    private String accTypeCode;

    @ApiModelProperty(value = "账户类型描述")
    @TableField("acc_type_desc")
    private String accTypeDesc;

    @ApiModelProperty(value = "账户数")
    @TableField("acc_sum")
    private Integer accSum;

    @ApiModelProperty(value = "月份数")
    @TableField("month_sum")
    private Integer monthSum;

    @ApiModelProperty(value = "单月最高逾期(透支)总额")
    @TableField("overdraft_max")
    private BigDecimal overdraftMax;

    @ApiModelProperty(value = "最长逾期(透支)月数")
    @TableField("over_month")
    private Integer overMonth;


}
