package com.kexun.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 被追偿信息汇总明细
 * </p>
 *
 * @author lgs
 * @since 2023-06-07
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_smry_recovered_detail")
@ApiModel(value="SmryRecoveredDetailEntity对象", description="被追偿信息汇总明细")
public class SmryRecoveredDetailEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "被追偿信息ID")
    @TableField("smry_recovered_id")
    private Long smryRecoveredId;

    @ApiModelProperty(value = "业务类型代码")
    @TableField("bus_type_code")
    private String busTypeCode;

    @ApiModelProperty(value = "业务类型描述")
    @TableField("bus_type_desc")
    private String busTypeDesc;

    @ApiModelProperty(value = "账户数")
    @TableField("acc_num")
    private Integer accNum;

    @ApiModelProperty(value = "余额")
    @TableField("balance")
    private BigDecimal balance;


}
