package com.kexun.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 大额专项分期信息
 * </p>
 *
 * @author lgs
 * @since 2023-06-12
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_trs_spec_prd")
@ApiModel(value="TrsSpecPrdEntity对象", description="大额专项分期信息")
public class TrsSpecPrdEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "账户编号")
    @TableField("acct_no")
    private String acctNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "大额专项分期额度")
    @TableField("spec_line")
    private BigDecimal specLine;

    @ApiModelProperty(value = "分期额度生效日期")
    @TableField("spec_sta_date")
    private String specStaDate;

    @ApiModelProperty(value = "分期额度到期日期")
    @TableField("spec_end_date")
    private String specEndDate;

    @ApiModelProperty(value = "已用分期金额")
    @TableField("inst_amt")
    private BigDecimal instAmt;


}
