package com.kexun.model.xml.trs;

import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * Description:特殊交易信息
 *
 * @author lgs
 * @date 2023/06/12
 */
@Data
public class TrsSpecDetail {

    /**
     * 账户编号
     */
    @JSONField(name = "ACCTNO")
    private String acctNo;

    /**
     * 特殊交易类型代码
     */
    @JSONField(name = "TRANTYPECODE")
    private String tranTypeCode;

    /**
     * 特殊交易类型描述
     */
    @JSONField(name = "TRANTYPEDESC")
    private String tranTypeDesc;

    /**
     * 特殊交易发生日期
     */
    @JSONField(name = "TRANDATE")
    private String tranDate;

    /**
     * 特殊交易变更月数
     */
    @JSONField(name = "TRANMONTH")
    private Integer tranMonth;

    /**
     * 特殊交易发生金额
     */
    @JSONField(name = "TRANAMT")
    private BigDecimal tranAmt;

    /**
     * 特殊交易明细记录
     */
    @JSONField(name = "DETRECORD")
    private String detRecord;

}
